<!DOCTYPE html>
<html>
  <head>
    <title>
      Machines Learning to Solve Sign Problems
    </title>
    <link rel="stylesheet" href="present.css" />
    <script src='present.js'></script>
    <link rel="stylesheet" media="print" href="print.css" />
    <script async src='/mathjax/tex-svg-full.js'></script>
  </head>
  <body>
    <noscript>
      <div style="font-size: 30pt;">Javascript really is required, sorry</div>
    </noscript>

    <!-- TITLE -->
    <header id="title">
      <h1>Machines Learning to Solve Sign Problems</h1>
      <div><img src="dall-e-2.png" style="width: 40vh; text-align: center;"/></div>
      <div class="author">Scott Lawrence</div>
      <div style="font-size: 120%">with Hyunwoo Oh, Yukari Yamauchi, <span style="font-size:80%">Andrei Alexandru, Paulo Bedaque, Henry Lamm, Neill Warrington<span></div>
      <div>September 5, 2022 at אוניברסיטת תל אביב</div>
      <div>
        <img src="boulder.png" style="width: 35vh; padding: 0 1em" />
      </div>
      <div></div>
    </header>

    <section id="gaussian-example">
      <header><h1>The Easiest Sign Problem</h1></header>
      <div class="flex-horiz" style="font-size: 80%">
      \[
      Z = \int d x\; e^{-x^2 - {\color{red}2 i \alpha x}}
      \]
      \[\color{blue}
      Z_Q = \int d x \; e^{-x^2}
      \]
      </div>
      <div class="flex-horiz"><div style="width: 70vh; padding: 2vh 0">
      <p>We must sample with respect to the <span style="color:blue">quenched</span> Boltzmann factor. Observables are computed via
      \[
      \langle \mathcal O \rangle = \frac{\langle\mathcal O e^{-i S_I} \rangle_Q}{\langle e^{-i S_I}\rangle_Q}
      \]
        </div><div>
      <p>The sign problem is measured by
      \[
      \langle \sigma\rangle \equiv \frac Z {Z_Q} \sim e^{-\alpha^2}
      \]</div></div>
      <hr>
      <div class="flex-horiz">
      <img src="gaussian-sign.png" style="width: 45vh"/>
      <img src="gaussian-contour.png" style="width: 45vh"/>
      </div>
      <footer></footer>
    </section>

    <section id="contour-deformations">
      <header><h1>Contour Integrals for the Sign Problem</h1></header>
      <div class="flex-horiz">
        <div style="margin: 0 5vh">
          <p>The Boltzmann factor \(e^{-S}\) is complex. Sample with \(e^{-S_R}\) and reweight.
          \[
          \langle\sigma\rangle = \frac{\int e^{-S}}{\int |e^{-S}|}
          \]
        </div>
        <div style="margin: 0 5vh">
          <img src="cauchy1d2.svg" style="width:40vh"/>
        </div>
      </div>
      <div class="flex-horiz">
        <span style="font-weight: bold; color:green; margin: 0 5vh">
          Theorem: the integral of a holomorphic function is unchanged by contour deformation.
        </span>
      </div>
      <footer></footer>
    </section>

    <section id="thirring">
	    <header><h1>Thirring Model</h1></header>
	    <p>Relativistic fermions in \(1+1\) dimensions with a repulsive 2-body interaction.
	    \[
	    S_{\mathrm{thirring}} = \frac 1 {2 g^2}\sum_{x,\mu} \big(1 - \cos A_\mu(x)\big)- \frac{N_f}{2} \log \det K[A]
	    \]
	    <p>The \(N_f=1\) theory is exactly solvable. Strong coupling marked by \(m_B \sim m_F\).
	    <center style="color:red">Sign problem exponentially bad in \(m^2 V\).</center>
	    <hr>
	    <div class="flex-horiz"><img src="flow.png" width="80%"/></div>
	    <footer>From <a href="https://arxiv.org/abs/1609.01730"><tt>arXiv:1609.01730</tt></a> (Alexandru, Basar, Bedaque, Ridgway, Warrington)</footer>
    </section>

    <section id="flow">
	    <header><h1>Finding Contours: Holomorphic Gradient Flow</h1></header>
	    <p>Evolve every point on the real plane according to the <b style="color: blue">holomorphic gradient flow</b>:
	    \[
	    \frac{d z}{dt} = \left({\frac{\partial S}{\partial z}}\right)^*
	    \]
	    For short flow times, improves the average sign by decreasing the quenched partition function. (Maximally efficient!)
	    \[
	    Z_Q = \int dz\, |e^{-S}|
	    \]

	    <div style="text-align: center; color:red">Alas, evolving this ODE at every sample is dreadfully slow.</div>
	    <p>For an \(8^4\) QCD lattice, evaluating the Jacobian determinant requires a \(10^5 \times 10^5\) matrix. (\(\sim 10\) times larger than the Dirac matrix)
	    <footer></footer>
    </section>

    <section id="machine-learning">
	    <header></header>
	    <div style="text-align:center"><img src="dall-e-1.png" width="60%"/></div>
	    <footer></footer>
    </section>

    <section id="dlblt">
	    <header><h1>Learning Flowed Contours</h1></header>
	    <div class="flex-horiz" style="margin: 0 3vh">
		    <div>
	    <p><b style="color:green">Algorithm:</b>
	    <ul>
		    <li>Sample many points from flowed manifold.
		    </li>
		    <li>Train neural network to approximate flow (supervised learning)</li>
		    <li>Run Monte Carlo using approximated flow.</li>
	    </ul>
	    \[
	    \mathop{\mathrm{Re}} A = M_3 \sigma[M_2 \sigma(M_1 \mathop{\mathrm{Im}} A)]
	    \]
	    <div class="flex-horiz"><img src="ff.png" width="60%" /></div>
		    </div>
		    <div>
			    <p><b style="color:red">Downsides:</b>
			    <ul>
				    <li>Determinant computation still required.</li>
				    <li>Many samples points required to train accurately.</li>
				    <li>Flowed manifold is not optimal!</li>
			    </ul>
		    </div>
	    </div>
	    <hr>
	    <footer>See <a href="https://arxiv.org/abs/1709.01971"><tt>arXiv:1709.01971</tt></a> (Alexandru, Bedaque, Lamm, Lawrence).<footer>
    </section>

    <section id="somme">
	<header><h1>Direct Contour Optimization</h1></header>
	<p>Evaluating \(\langle \sigma \rangle\) itself is hard. The sign problem manifests as a signal-to-noise problem.
	<p>But, we don't need to! We just need to minimize \(Z_Q\), and
	\[\color{green}
	\frac{d}{d t}\lambda = - \frac{\partial}{\partial \lambda} \log Z_Q
	\]
	has the form of a quenched (i.e., sign-free) observable!
	<hr>
	<p>This isn't complex analysis---it's a general principle. Contour deformations:
	<ul>
		<li>Leave \(Z\) alone, while</li>
		<li>Potentially modifying \(Z_Q\).
	</ul>
	<p>Any strategy with those properties can be optimized in the same way.
	<footer>See: 1804.00697, 1808.09799, 1810.06529</footer>
    </section>

    <section id="fermion-contours">
      <header><h1>Early Success: Thirring Model</h1></header>
      <div class="flex-horiz">
      <img src="thirring.png" width="80%" />
      </div>
      <hr>
      <p>Best results obtained with a simple ansatz, rather than a deep neural network:
      \[
      \mathop{\mathrm{Im}} A_0(x) = a
      + b \cos \mathop{\mathrm{Re}} A_0(x)
      + c \cos \mathop{\mathrm{Re}} 2 A_0(x)
      \]
      <footer>See arXiv:1804.00697. Calculation on a 20x10 lattice, with Wilson fermions, fermion mass 0.3, boson mass 0.44</footer>
    </section>

    <section id="normalizing">
      <header><h1>Another Perspective: Normalizing Flows</h1></header>
      <span style="text-align: center"><img src="kanwar.png" style="width:65vh" /></span>
      <div class="flex-horiz" style="margin: 2vh; font-size: 80%">
        <div>
          <p>Goal: sample from \(p(z)\)
          <p>A <strong>normalizing flow</strong> is a map \(\phi\)
          \[
          \int_{-\infty}^x e^{-x^2} dx = \int_{-\infty}^{\phi(x)} p(z)\, dz
          \]
          <p style="color: green">Sample from the Gaussian, then apply \(\phi\).
          <p>(Any easily sampled distribution can replace the Gaussian.)
        </div>
        <div style="height: 40vh; border: 1px solid #888888; margin: 2vh"></div>
        <div>
          <p style="color: red; font-weight: bold">What if \(\phi(x)\) is complex?
          <p>Complex normalizing flow \(\Rightarrow\) contour deformation
        </div>
      </div>
      <div class="flex-horiz">
        <span style="font-weight: bold; color: blue; font-size: 90%; padding: 3vh 0">A complex normalizing flow gives a locally perfect contour deformation</span>
      </div>
      <footer></footer>
    </section>

    <section id="analytic-continuation">
      <header><h1>Analytic Continuation of Normalizing Flows</h1></header>
      <p>Here's a normalizing flow for scalar field theory:
      <div class="flex-horiz">
        <img src="sft-nf.png" />
      </div>
      <p>What if \(M,\Lambda\) are complex? Doesn't matter; still a good normalizing flow.
      <div class="flex-horiz">
        <span style="font-weight: bold; color: green">Normalizing flows are analytic in action parameters</span>
      </div>
      <hr />
      <div>
      <div class="flex-horiz">
        <span style="font-weight: bold; color: blue; font-size: 110%; padding: 3vh 0">To summarize:</span>
      </div>
      <ul>
        <li>Normalizing flows always exist for real distributions (theorem)</li>
        <li>These can be analytically continued for complex parameters (ideology)</li>
        <li>Complex normalizing flow gives (locally perfect) integration contour</li>
      </ul>
      </div>
      <footer></footer>
    </section>

    <section id="complex-sft">
	    <header><h1>Scalar Field Theory at Complex Coupling</h1></header>
	    \[
	    S = \int dx\, \frac 1 2 \left(\frac{\partial\phi}{\partial x}\right)^2 + \frac {m^2}{2} \phi(x)^2 + \lambda \phi(x)^4
	    \]
	    <p>At \(\mathop{\mathrm{Im}}\lambda \ne 0\), this model has a sign problem. Train a contour as before, and the sign problem nearly disappears:

	    <div class="flex-horiz">
		    <img src="scc-sign.png" width="40%"/>
		    <img src="scc-vf.png" width="40%"/>
	    </div>
	    <footer>See <tt>arXiv:2205.12303</tt> (Lawrence, Oh, Yamauchi).  Left: \(m^2=0.5\) and \(\lambda = i\), on an \(L\times L\) lattice. Right: an \(8\times 8\) lattice. Using a linear contour deformation.</footer>
    </section>

    <section id="nf-training">
	    <header><h1>Cost Function for Normalizing Flows</h1></header>
\begin{align}
C_{\mathrm{nf}}(\lambda) &amp;=
\Bigg\langle\bigg|\underbrace{\frac{\phi^2}{2} - \Re\log\mathcal N - \Re S(\tilde\phi_\lambda(\phi)) - \Re \log \frac{\partial\tilde\phi_\lambda}{\partial\phi}}_{\Re (S_{\mathrm{induced}} - S)}\bigg|^2\Bigg\rangle_n\\
&amp;+
\Bigg\langle\bigg|1-\underbrace{\Big(\mathop{\mathrm{csgn}} \frac{\partial \tilde\phi_\lambda}{\partial \phi}\Big)e^{-i\Im \left(S(\tilde\phi_\lambda(\phi)) + \Im \log \mathcal N\right)}}_{e^{-i \Im \left(S_{\mathrm{induced}} - S\right)}}\bigg|^2\Bigg\rangle_n
\text.
\end{align}
	    <div style="margin: 0vh 5vh"><span style="color:green"><b>Adiabatic training</b>: Start at real \(\lambda\) and rotate \(\lambda\) while tracking a "good" contour (or normalizing flow).</span></div>
		<footer></footer>
    </section>

    <section id="complex-sft-plots">
	    <header><h1>Analytically Continued Scalar Field Theory</h1></header>
	    \[
	    Z(\lambda) = \int \mathcal D\phi\, e^{- (\cdots + \lambda \int \phi^4)}
	    \]
	    <p>For \(\mathop{\mathrm{Re}}\lambda &lt; 0\) the partition function can be defined only by analytic continuation. This is a "worse than infinitely bad sign problem".
	    <div class="flex-horiz">
	    <img src="ac.png" width="60%"/>
	    </div>
	    <footer>Partition function on a 0+1 lattice with \(m^2=0.5\), from a normalizing flow with one hidden layer.</footer>
    </section>

    <section id="do-manifolds-exist">
      <header><h1>Do Perfect Contours Exist?</h1></header>
      <p><b>Wanted</b>: a manifold such that
      \[
      \left|\int e^{-S} \;d z\right|=\int \left|e^{-S} \;dz\right|
      \]
      <div class="flex-horiz"><span style="font-weight: bold; color: blue">This does not automatically solve the sign problem!</span></div>
      <ul>
        <li>Perfect manifolds might be hard to find</li>
        <li>Hard to sample from</li>
        <li>Observables may have signal-to-noise problem</li>
      </ul>
      <footer></footer>
    </section>

    <section id="example-polynomial">
      <header><h1>Example: One-Dimensional Integrals</h1></header>
      \[
      Z = \int dz\;e^{-z^2 - \lambda e^{i\theta} z^4}
      \]
      <div class="flex-horiz">
        <img style="width:80vh" src="manifolds1d.png" />
      </div>
      <footer></footer>
    </section>

    <section id="example-thimbles">
      <header><h1>Example: One-Dimensional Integrals</h1></header>
      \[
      Z = \int dz\;e^{z^2 - e^{i} z^4 - i z^3}
      \]
      <div class="flex-horiz">
        <img style="width:80vh" src="thimbles1d.png" />
      </div>
      <footer></footer>
    </section>

    <section id="example-cos">
      <header><h1>Example With No Perfect Manifold</h1></header>
        \[ Z = \int (\cos \theta + \epsilon) \;d \theta\]
      <div class="flex-horiz">
        <div>
          <p> \[Z = 2 \pi \epsilon\]
          <p> Quenched partition function is \(O(1)\)
        </div>
        <div>
          <img src="cos-example.png" style="width:70vh" />
        </div>
      </div>
      <hr>
      <div class="flex-horiz">
        <span style="margin: 0 18vh; color:red; font-weight:bold">Similar methods reveal that no manifold exists for the mean-field Thirring model.</span>
      </div>
      <footer></footer>
    </section>

    <section id="subtractions">
	    <header><h1>Directly Modifying the Boltzmann Factor</h1></header>
	    <div class="flex-horiz" style="color:green"><span>Modify the partition function by subtracting any function \(g(\phi)\) that integrates to \(0\)</span></div>
	    \[ Z = \int d\phi\,e^{-S(\phi)} \rightarrow \int d\phi\,\left( e^{-S(\phi)} - g(\phi) \right)\]
	    <p>Physics (the partition function as a function of various sources) is unchanged, but the sign problem...</p>
	    \[
	    Z_Q = \int \left|e^{-S(\phi)}\right| \ne \int \left|e^{-S(\phi)} - g(\phi)\right|  = \tilde Z_Q
	    \]
	    <p><b>All contour deformations are subtractions:</b> \(\int d\phi\, f(\phi) - f(\tilde\phi(\phi)) = 0\)
	    <footer>See also "control variates"</footer>
    </section>

    <section id="subtraction-existence">
	    <header><h1>Perfect Subtractions Exist</h1></header>
	    <div class="flex-horiz" style="color:green"><span>For any sign problem, a subtraction exists that removes it.</span></div>
	    \[g(\phi) =  e^{-S(\phi)} - \frac{\int d\phi\,e^{-S(\phi)}}{\int d\phi} \]
	    <p>This is not unique, but it is "close" to unique. Adding a generic function \(\tilde g \sim e^{-S}\) breaks the subtraction. Adding a generic function \(\tilde g \sim Z_Q\) is okay.
	    <p>General trick to obtain functions that integrate to \(0\): \(g(\phi) = \frac{\partial}{\partial \phi_i} v_i\). (<em>Almost</em> useful for machine learning, but \(v \sim e^{-S}\) is required.)
	    <footer></footer>
    </section>

    <section id="subtraction-perturbative">
	    <header><h1>Perturbative Subtractions</h1></header>
	    <div class="flex-horiz" style="color:green">Any systematic expansion can be used to obtain a subtraction.</div>
	    <p>Heavy-dense limit: a lattice expansion in large \(\mu\):
	    \[
	    \det K[A] = {\color{blue}2^{-\beta V} e^{\beta V \mu + i \sum_x A_0(x)}} + O(e^{\beta (V-1) \mu})
	    \]
	    <div class="flex-horiz"><img src="sub-hd.png" width="90%"/></div>
	    <footer>See <tt>2009:10901</tt> (Lawrence).</footer>
    </section>

    <section id="sub-training">
	    <header><h1>Learning Subtractions</h1></header>
	    <div style="font-size:80%">
	    \[
	    Z = \int e^{-S} \rightarrow \int e^{-S}\left(1 - v \cdot \nabla S + \nabla \cdot v\right)
	    \]
	    </div>
	    <p>This form of subtraction is the same, at leading order in \(v\), as performing an infintesimal contour deformation.
	    <div style="font-size:80%">
	    \[
	    \langle \mathcal O\rangle
	    = \frac{\int e^{-S} \mathcal O}{\int e^{-S}}
	    \rightarrow
	    \frac{\int e^{-S} \left(1 - v \cdot \nabla S + \nabla \cdot v\right)
	    \left(\mathcal O - \frac{v \cdot \nabla \mathcal O}{\left(1 - v \cdot \nabla S + \nabla \cdot v\right)
}\right)
}{\int e^{-S}\left(1 - v \cdot \nabla S + \nabla \cdot v\right)
}
\]</div>
	    <p style="color:blue">Other procedures for measuring observables generally result in terrible signal-to-noise.

	    <p>Training a 2-layer network on a 6-by-6 lattice with \(m_B = 0.33(1)\), \(m_F=0.35(2)\):

	    <div class="flex-horiz">
		    <img src="sub-6-sign.png" width="40%" />
		    <img src="sub-6-n.png" width="40%" />
	    </div>
	    <div class="flex-horiz" style="color:red"><b>Does this trick (meaningfully) undermine the existence guarantees?</b></div>
	    <footer></footer>
    </section>

    <!-- CLOSING -->
    <section id="closing">
      <header></header>
      <div class="flex-horiz"><img src="dall-e-5.png"  width="60%"/></div>
      <footer></footer>
    </section>

    <div id="present-control">
      <div id="position"><span id="pos-cur"></span>/<span id="pos-len"></span></div>
      <a href='javascript:prev()'>&lt;</a>
      <a href='javascript:next()'>&gt;</a>
    </div>
  </body>
</html>
